package com.terraocean.plugin

import com.terraocean.plugin.listeners.onPlayerMovement
import com.terraocean.plugin.bridge.establishConnection
import com.terraocean.plugin.listeners.onPlayerJoin
import com.terraocean.plugin.listeners.onPlayerPreLogin
import hazae41.minecraft.kutils.bukkit.*

internal lateinit var instance: TerraOceanPlugin

class TerraOceanPlugin: BukkitPlugin() {
    override fun onEnable() {
        instance = this
        Messages // Initialize the config classes
        Settings

        joinListeners()

        schedule(async = true) {
            instance.info("establishing connection to ${Settings.socketURL}...")
            establishConnection()
        }
    }

    private fun joinListeners() {
        listen(callback = ::onPlayerMovement)
        listen(callback = ::onPlayerPreLogin)
        listen(callback = ::onPlayerJoin)
    }
}
